THE FOLLOWING PATCHES WILL FIX PROBLEMS FOUND IN THE TERMINAL EMULATOR
SUPPLIED WITH MACFORTH 1.1 AND ALSO ADD THE FOLLOWING NEW FEATURES:
 
1) EMULATOR WILL RUN IN FULL OR HALF DUPLEX MODE (DEFAULT IS FULL).
   TYPE "FULL DUPLEX" OR "HALF DUPLEX" AT OK PROMPT BEFORE TYPING HOST.
2) OPT-B WILL SEND A BREAK.
3) OPT-BACKSPACE WILL SEND A DELETE (RUBOUT).
4) UNDERLINE CURSOR IS IMPLEMENTED.
 
DOES NOT FIX CURSOR FREEZE PROBLEM.
THE FOLLOWING CHANGES CORRESPOND TO THE ORIGINAL SCREENS/LINES:
 
SCR #15
 4 CREATE ECHO 0 ,  0 CONSTANT FULL  1 CONSTANT HALF
 8 CREATE SERIAL.OPTIONS  HEX FFFF1113 , 000000FF , DECIMAL
 
SCR #16
11 : S.BREAK (  -- SEND BREAK )
12      0 0 12 SERIAL.OUT >FCB DEVICE.CONTROL
13      TICKCOUNT 6+ BEGIN DUP TICKCOUNT < UNTIL DROP
14      0 0 11 SERIAL.OUT >FCB DEVICE.CONTROL  ;
15 : DUPLEX ECHO !  ; ( FLAG -- SET ECHO )
 
SCR #17
 8 : BACKSPACE (  --  )
 9      DROP @PEN SWAP BL CHARWIDTH - SWAP
10      2DUP (MOVE.TO) BL DRAW.CHAR (MOVE.TO)  ;
11
12 : ECHO.SERIAL (  -- ECHO SERIAL INPUT TO CONSOLE SCREEN )
13      PAD S.?TERMINAL 2DUP S.EXPECT OVER + SWAP
14      DO IC@ 127 AND DUP 8 = IF BACKSPACE ELSE EMIT THEN
15      LOOP  ;
 
SCR #19
 5   01130406 , 08071A18 , 03160002 , 11170512 ,
 8   0000007F , 00000000 , 00000000 , 00000000 ,
12      IF DROP KEY.STROKE 6+ C@ 3F AND OPTION.KEYMAP + C@ THEN
 
SCR #20
 1 : D_ (  -- DRAW/ERASE CURSOR )
 2      6 0 (LINE) -6 0 (MOVE)  ;
 3
 4 : >HOST< ( ENTER HOST COMMUNICATION )
 5      BEGIN
 6         S.?TERMINAL
 7            IF D_ ECHO.SERIAL D_ THEN
 8         ?TERMINAL IF KEY.STROKE 7+ C@
 9            MAP>OPTION KEY.STROKE OFF
10            DUP 126 = IF DROP EXIT THEN      ( <~>     QUIT  )
11            DUP   2 = IF DROP S.BREAK ELSE   ( <OPT-B> BREAK )
12               ECHO @ IF DUP DUP 8 =
13                  IF D_ BACKSPACE D_ ELSE D_ EMIT D_ THEN THEN
14               S.EMIT THEN THEN
15      AGAIN  ;
 
SCR #21
10      CR ." --ONLINE--" CR
11      PATXOR PENMODE D_
12         >HOST<
13      D_ PATCOPY PENMODE
14      CR ." --OFFLINE--" CR
15      TEXTMODE TEXTSIZE  ;
 
 
          WILLIAM BOND 74435,160
 
